︠58862490-c9aa-47e9-87d3-4e450a617d67︠
def P(n):
    list = []
    for a in [1..n]:
        if gcd(a, n) == 1:
            list.append(a)
    return list

def prod_P(list, n):
    prod_P = Mod(1, n)
    for a in list:
        prod_P = prod_P * a
    return prod_P

def find_counterexample(range):
    for n in range:
        list = P(n)
        prod = prod_P(list, n)
        if int(prod) - n != -1:
            print "First counterexample for n in %s is for n = %s. P = %s"%(range, n, list)
            return
    print "No counterexample found for n in %s"%range
            
find_counterexample(range(1, 11))
︡3175ec25-5f24-4452-a2bf-93341cc013ef︡{"stdout": "First counterexample for n in [1, 2, 3, 4, 5, 6, 7, 8, 9, 10] is for n = 8. P = [1, 3, 5, 7]"}︡
︠ba503ca5-8a4a-4247-b616-f9b8317083e6︠
def check_crt(a, b, m, n):
    x = CRT(a, b, m, n)
    print "x = %s"%x
    
    if Mod(x, m) == a:
        print "x is congruent to %s (mod %s)"%(a, m)
    else:
        print "Failed check! x is *not* congruent to %s (mod %s)"%(a, m)

    if Mod(x, n) == b:
        print "x is congruent to %s (mod %s)"%(b, n)
    else:
        print "Failed check! x is *not* congruent to %s (mod %s)"%(b, n)
        
    return x

a = 3
b = 5
m = 7
n = 11
x = check_crt(a, b, m, n)

print ""

a = -1
b = 1
m = 2010
n = 2011
x = check_crt(a, b, m, n)
︡b174d38b-e6ff-4322-86cb-8e1009a8dc95︡{"stdout": "x = -39\nx is congruent to 3 (mod 7)\nx is congruent to 5 (mod 11)\n\nx = -4021\nx is congruent to -1 (mod 2010)\nx is congruent to 1 (mod 2011)"}︡
︠bb260e58-281e-4067-8b8c-d27826113ea2︠
for n in [0..99]:
    if Mod(n, 100)^2 - 1 == 0:
        print n
︡bfad243a-36bd-4218-8e90-dd8e96503c4d︡{"stdout": "1\n49\n51\n99"}︡
︠41a1ff1a-6920-40b2-9ff6-de5e84215f0f︠
def check_primes(stop):
    for n in prime_range(stop):
        d = Mod(2, n)
        if d^(n-1) == -1:
            print "Found a prime such that 2^(n-1) is congruent to -1 (mod n). n = %s"%n
            return
    print "Could not find a prime <= %s such that 2^(n-1) is congruent to -1 (mod n)"%stop

check_primes(100000)
︡29d6081f-28b1-4427-a6c6-e3c936a915e5︡{"stdout": "Could not find a prime <= 100000 such that 2^(n-1) is congruent to -1 (mod n)"}︡
︠0ec6565c-ecce-47b7-8573-49ab42b06aaa︠
a = 7
b = -1
m = 5
n = 2011
x = (check_crt(a, b, m, n) - 7) / 5
if Mod(5 * x + 7, 2011):
    print "x = %s is a solution"%x
︡9591babb-fbc4-4da2-a817-b754f545f771︡{"stdout": "x = 16087\nx is congruent to 7 (mod 5)\nx is congruent to -1 (mod 2011)\nx = 3216 is a solution"}︡
